// Copyright 2020 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_MOJO_CORE_LIBRARY_SUPPORT_H_
#define CONTENT_COMMON_MOJO_CORE_LIBRARY_SUPPORT_H_

#include "base/files/file_path.h"
#include "base/optional.h"
#include "content/common/content_export.h"

namespace content {

// Indicates whether the calling process was launched with the option to
// initialize Mojo Core from a shared library rather than the statically linked
// implementation.
CONTENT_EXPORT bool IsMojoCoreSharedLibraryEnabled();

// Returns the path to the Mojo Core shared library passed in on the command
// line for the calling process, or null if the process was launched without a
// Mojo Core library path on the command line.
CONTENT_EXPORT base::Optional<base::FilePath> GetMojoCoreSharedLibraryPath();

}  // namespace content

#endif  // CONTENT_COMMON_MOJO_CORE_LIBRARY_SUPPORT_H_
